/*
 * TestGraficos.java
 *
 * Creado el 14 de mayo de 2006, 20:40
 */


package interpolacionYAproximacion.practica10;

import auxiliar.*;

/* Los siguientes paquetes se necesitan para usar el potencial grfico de JAVA */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * El objetivo de esta aplicacin es usar un panel de dibujo (instanciando
 * un objeto de la clase PanelDibujo) para pintar la grfica de la funcin seno,
 * y una elipse centrada en el origen con
 * semiejes tambin definidos por el usuario junta las circunferencias inscrita 
 * y circunscrita en la misma.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class TestGraficos {
    
    public static void main(String args[]) {
        
        /**
         * Instanciamos los objetos pd de la clase PanelDibujo y el objeto 
         * seno de la clase Funcion1 y f de la clase Funcion2 (ambas 
         * implementan la interfaz Funcion). Definimos unas variables 
         * auxiliares que necesitaremos en el programa. Durante la ejecucin 
         * de la aplicacin, tras instanciar pd, se abre inmediatamente en 
         * pantalla una ventana en la que iremos haciendo nuestros dibujos.
         */        
        PanelDibujo pd = new PanelDibujo();
        
        /**
         * En este punto de la ejecucin de la aplicacin aparece una ventana 
         * vaca con el ttulo "Dibujo de curvas en el plano".
         */
        FuncionSeno seno = new FuncionSeno();        
        double a; 
        double b;
        int n;
        double[][] xy0;
        double[][] xy1;
        double[][] xy2;
                
        /**
         * El mtodo addEjesCoordenados hace que la ventana "sepa" que deben 
         * pintarse unos ejes coordenados; con repaint se "da la orden" de que 
         * se pinten. La primera instruccin no tiene nada que ver con las 
         * siguientes: simplemente abre en pantalla una ventana independiente 
         * de la anterior, que nos manda un mensaje informativo y se cierra 
         * tras pulsar OK.
         */        
        JOptionPane.showMessageDialog(null, "Pulsa OK para empezar");
        pd.addEjesCoordenados(true);
        pd.repaint();
        
        /**
         * El siguiente bloque de instrucciones sirve para algunos datos 
         * que necesita la aplicacin (los extremos izquierdo a y derecho b del 
         * intervalo en el que queremos representar la funcin seno y el nmero 
         * n de puntos que vamos a utilizar). Los mtodos verificarDouble y
         * verificarInt (construidos al final de la clase) reciben los
         * datos que necesitamos como String y los traducen a double e int
         * respectivamente.
         */
        a = 0;
        b = 0;
        n = 0;
        while ((b <= a) || (n < 2)) {
            JOptionPane.showMessageDialog(null,
                    "Introduce datos para pintar la funcin seno");
            a = verificarDouble("Extremo izquierdo del intervalo:");
            b = verificarDouble("Extremo derecho del intervalo:");
            n = verificarInt("Nmero de puntos de la grfica:");
            if ((b <= a) || (n < 2)) {
                JOptionPane.showMessageDialog(null, 
                        "Error: datos no consistentes");
            }
        }
        
        /**
         * La siguiente instruccin "enva" la funcin seno a la ventana
         * para que la almacene y pinte posteriormente, de color verde, 
         * la poligonal que conecta a los n puntos de su grfica cuyas 
         * primeras coordenadas estn igualmente espaciados en el 
         * intervalo [a, b]. Si esta cantidad de puntos es suficientemente 
         * grande, la poligonal se asemejar bastante a la grfica de la 
         * funcin seno en dicho intervalo.
         */        
        JOptionPane.showMessageDialog(null, 
                "Pulsa OK para pintar la funcin seno");
        pd.addCurva("verde", seno, n, a, b);
        pd.repaint();
                
        /**
         * A continuacin mandamos un mensaje a la ventana para que borre
         * la curva seno pintada.
         */        
        JOptionPane.showMessageDialog(null, "Pulsa OK para borrar la curva");
        pd.removeCurvas();
        pd.repaint();
        
        /* Pedimos los datos necesarios para pintar la elipse */ 
        a = 0;
        b = 0;
        n = 0;
        while ((a <= 0) || (b <= 0) || (n < 2)) {
            JOptionPane.showMessageDialog(null,
                    "Introduce datos para pintar la elipse y las " +
                    "circunferencias");
            a = verificarDouble("Semieje horizontal de la elipse");
            b = verificarDouble("Semieje vertical de la elipse:");
            n = verificarInt("Nmero de puntos de cada grfica:");
            if ((a <= 0) || (b <= 0) || (n < 2)) {
                JOptionPane.showMessageDialog(null, 
                        "Error: datos no consistentes");
            }
        }   
        
        /**
         * En la matriz xy0 guardamos una lista de n puntos de la elipse
         * de semiejes a y b centrada en el origen de coordenadas, y en las
         * matrices xy1 y xy2 hacemos lo propio para las circunferencias de
         * radios a y b. Para ello usamos las parametrizaciones habituales, 
         * espaciando los puntos calculados en funcin del paramtro t. 
         */        
        xy0 = new double [n][2];
        xy1 = new double [n][2];
        xy2 = new double [n][2];
        for (int t = 0; t < n; t++){
            xy0[t][0] = a * Math.cos(2 * Math.PI * t / (n - 1));
            xy0[t][1] = b * Math.sin(2 * Math.PI * t / (n - 1));
            xy1[t][0] = a * Math.cos(2 * Math.PI * t / (n - 1));
            xy1[t][1] = a * Math.sin(2 * Math.PI * t / (n - 1));
            xy2[t][0] = b * Math.cos(2 * Math.PI * t / (n - 1));
            xy2[t][1] = b * Math.sin(2 * Math.PI * t / (n - 1));
        }
        
        /**
         * Se envan las listas de puntos a la ventana indicando los colores que 
         * queremos usar para pintarlas.
         */        
        pd.addCurva("rojo", xy0);
        pd.addCurva("azul", xy1);
        pd.addCurva("negro", xy2);
        
        /**
         * La instruccin siguiente hace que se pinten en la ventana las curvas
         * que se le han mandado.
         */        
        pd.repaint();
        
        /**
         * Finalmente enviamos una orden para que la ventana abierta se 
         * pueda cerrar correctamente y as detener la aplicacin.
         */        
        JOptionPane.showMessageDialog(null,
                "Pulsa OK y cierra la ventana para acabar la aplicacin");
        pd.addWindowListener(
                new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        }
        );
        
    } // acaba el metodo main de la aplicacin TestGraficos
    
    public static int verificarInt(String pregunta) {         
        boolean datosErroneos = true;
        String aux;
        int n = 0;
        
        while (datosErroneos) {
            try {
                datosErroneos = false;
                aux = JOptionPane.showInputDialog(pregunta);
                n = Integer.parseInt(aux);            
            } catch(Throwable errDatos) {
                datosErroneos = true;
                JOptionPane.showMessageDialog(null,
                        "Error: el dato introducido no es entero");
            }
        }
        return n;
    }
    
    public static double verificarDouble(String pregunta) {         
        boolean datosErroneos = true;
        String aux;
        double a = 0;
        
        while (datosErroneos) {
            try {
                datosErroneos = false;
                aux = JOptionPane.showInputDialog(pregunta);
                a = Double.parseDouble(aux);                        
            } catch(Throwable errDatos) {
                datosErroneos = true;
                JOptionPane.showMessageDialog(null,
                        "Error: el dato introducido no es real");
            }
        }
        return a;
    }        
    
} // acaba la aplicacin TestGraficos


